How to contribute
=================

This project is and will probably never be perfect, because we all make mistakes.
It is therefore not a matter of never making mistakes, but of achieving sustainable improvements from them.

Use issues
----------

* Changes to the code always require an [issue](https://https://gitlab.com/tuda-fzd/perception-sensor-modeling/osmpsensorframework/-/issues).
* Closed issues may only be reopened and reused if the issue was not successfully closed and the change is intended to fix the issue. 
* Describe briefly and concisely the goal to be achieved.

Use pull-requests
------------------

* Create a PR for the development or feature branch, if such a branch already exists.
* Never create a new branch that is not associated with an issue. 

Use small commits
-----------------

* Add many small commits instead of a few large ones.
* Each commit should serve exactly one objective.
  If you cannot describe the commit in detail in the commit message, this indicates that there are multiple objectives.
* Use the imperative Active and, if possible, a short sentence describing the background of the change:
  "Improve project objective" instead of "Updated README".

Use coding guidelines
---------------------

Use the [C++ Core Guidelines](https://github.com/isocpp/CppCoreGuidelines/blob/master/CppCoreGuidelines.md).
